<?php

namespace App\Exports;

use App\Models\Order;
use App\Models\UserCity;
use App\Models\City;

//use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\WithHeadings;

class VendorDispatchReportExport implements FromArray,WithHeadings
{
    private $orderAssigned;

    public function __construct($from,$to,$vendor,$status)
    {

        if(Auth()->user()->hasAnyRole('admin','vendor_admin'))
        {
            if($from && $to && $vendor <> 'any' && $status <> 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->where('order_status',$status)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor == 'any' && $status <> 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->where('order_status',$status)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor <> 'any' && $status == 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor == 'any' && $status == 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }       
    
            else
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
        }
        elseif(Auth()->user()->hasAnyRole('middle_man','financer','sales','first_man','sales','bd','bdm','csr','cashier'))
        {
            $userid = Auth()->user()->id;
            $usercity = UserCity::where('user_id',$userid)->pluck('city_id');
            $cities = City::whereIn('id',$usercity)->get();
            
            if($from && $to && $vendor <> 'any' && $status <> 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->where('order_status',$status)->whereIn('consignee_city',$usercity)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor == 'any' && $status <> 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->where('order_status',$status)->whereIn('consignee_city',$usercity)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor <> 'any' && $status == 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->whereIn('consignee_city',$usercity)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
            elseif($from && $to && $vendor == 'any' && $status == 'any')
            {
                    $orderAssigned = Order::where('parcel_nature',1)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->whereIn('consignee_city',$usercity)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }       
    
            else
            {
                    $orderAssigned = Order::where('parcel_nature',1)->where('vendor_id', $vendor)->whereDate('created_at', '>=', $from)->whereDate('created_at', '<=', $to)->whereIn('consignee_city',$usercity)
                ->with([
                    'vendorWeight' => function($query){
                        $query->select('id','ahl_weight_id','price','city_id')->with([
                        'ahlWeight' =>  function($query){
                            $query->select('id','weight');
                        },
                        'city' => function($query){
                            $query->select('id','name');
                        },
                        ]);
                    },
                    'orderStatus' => function($query){
                        $query->select('id','name');
                    }
                ])
                ->get();
            }
        }
        
        
        //->toArray();
        //dd($orderAssigned);
        $this->orderAssigned = $orderAssigned;
    }
    /**
    * @return \Illuminate\Support\Collection
    */
    public function array(): array
    {
        $orderAssigneds = $this->orderAssigned;
        
        foreach ($orderAssigneds as $key => $orderAssigned) {
            // code...
            $data[] = [
                $orderAssigned->order_reference,
                $orderAssigned->vendor ? $orderAssigned->vendor->vendor_name : 'N\A',
                Date('d-m-Y',strtotime($orderAssigned->created_at)),
                $orderAssigned->consignment_order_id,
                $orderAssigned->consignee_first_name.''.$orderAssigned->consignee_last_name,
                $orderAssigned->consignee_phone,
                $orderAssigned->consignee_address,
                Date('d-m-Y',strtotime($orderAssigned->scanOrder ? $orderAssigned->scanOrder->created_at : '')),
                Date('d-m-Y',strtotime($orderAssigned->scanOrder ? $orderAssigned->scanOrder->supervisor_scan_date : '')),
                $orderAssigned->orderStatus->name,
                'Lahore',
                $orderAssigned->consignment_pieces,
                $orderAssigned->vendorWeight->ahlWeight->weight . ' ('. $orderAssigned->vendorWeight->city->first()->name . ')',
                $orderAssigned->vendor_weight_price,
                $orderAssigned->consignment_cod_price,
            ];
        }
        
        if(isset($data)){
            return $data;
        }else{
            return [];
        }
    }

    public function headings(): array
    {
        return [
            'order_reference',
            'vendor_name',
            'booking_date',
            'consignment_order_id',
            'consignee_name',
            'consignee_phone',
            'consignee_address',
            'pickup_date',
            'dispatch_date',
            'order_current_status',
            'destination',
            'order_pieces',
            'vendor_order_weight',
            'vendor_order_weight_price',
            'consignment_cod_price',
        ];
    }
}
