<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

use App\Models\Vendor;
use App\Models\Order;
use App\Models\OrderAssigned;
use App\Models\Packing;
use App\Models\Status;
use App\Models\OrderType;
use App\Models\ScanOrder;
use App\Models\WarehouseLocation;
use App\Models\VendorWeight;

use App\Helpers\Helper;

use Maatwebsite\Excel\Facades\Excel;
use App\Exports\BulkExport;
use App\Imports\BulkImport;

class OrderController extends Controller
{
    
    public function trackingLink(Request $request)
    {
        $id = $request->customer_ref;
//        dd($id);
        
        $order_detail = Order::where('order_reference', '=',$id)->first();
       // dd($order_detail);
        if(!empty($order_detail))
        {
            $order_id = $order_detail->id;
            return redirect()->route('tracking.order',$order_id);
        }
        else
        {
            return redirect()->route('no_tracking');
        }
    }
    
    public function trackOrder($id)
    {
        $model = Order::find($id);
        $decline = OrderAssigned::where(['order_id'=>$model->id,'status'=>0])
        ->with([
            'orderDecline' => function($query){
                $query->select('id','order_assigned_id','order_decline_status_id','order_decline_reason_id','additional_note','image')->with([
                    'orderDeclineStatus' => function($query){
                        $query->select('id','name');
                    },
                    'orderDeclineReason' => function($query){
                        $query->select('id','name');
                    },
                ]);
            }
        ])
        ->orderBy('id', 'DESC')->first();
        
        return view('tracking', compact('model','decline'));
    }
}
