<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class UserDetail extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        //'country_id',
        //'state_id',
        //'city_id',
        'user_id',
        'created_by',
        'cnic',
        'vehicle',
        'salary',
        'commission',
        'phone',
        'address',
    ];

    public function createdBy()
    {
        return $this->hasOne(User::class, 'id', 'createdBy');
    }

    /*public function userCountry()
    {
        return $this->hasOne(Country::class, 'id', 'country_id');
    }*/

    /*public function userState()
    {
        return $this->hasOne(State::class, 'id', 'state_id');
    }*/

    /*public function userCity()
    {
        return $this->hasOne(City::class, 'id', 'city_id');
    }*/

    public function user()
    {
        return $this->hasOne(User::class, 'user_detail_id', 'id');
    }

    public function assignCity()
    {
        return $this->hasMany(AssignCity::class, 'user_detail_id', 'id');
    }

    
}
